// Rozwiazywanie ukladow rownan liniowych
// Program Equations;

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int n;                                		// rozmiar problemu
int rl,rg,rp,rd;                     		// polozenie ramki z wynikami
int z1[11],z2[11];                        	// indeksy zmiennych
float a[11][11];                          	// tablica elementow
int r,k;                             		// element centralny
float eps;                                	// dokladnosc obliczen
char ss[10];

void ramka(int l,int g,int p,int d,int kp,int ka)
{
										   // g  - gorny rog
  int i,m;		                           // d  - dolny rog
										   // p  - prawy rog
  window(l,g,p,d);                         // kp - kolor podloza
  textbackground(kp);                      // ka - kolor atramentu
  textcolor(ka);
  clrscr();
  window(l,g,p+1,d+1);
  cprintf("");
  for(i=1; i< p-l;i++) cprintf("");
  cprintf("");
  for(i=2; i<= d-g; i++)
  {
	gotoxy(1,i);
	cprintf("");
  }
  i=d-g+1;
  gotoxy(1,i);
  cprintf("");
  for(i=1; i< p-l; i++) cprintf("");
  cprintf("");
  m=p-l+1;
  for(i=2; i<= d-g; i++)
  {
	gotoxy(m,i);
	cprintf("");
  }
  window(1,1,80,25);
}

void prolog(void)                           // poczatek pracy programu
{
  textbackground(0);
  clrscr();
  ramka(1,1,79,3,0,3);
  textcolor(11);
  gotoxy(2,2);
  cprintf ("R O Z W I A Z Y W A N I E    U K L A D O W");
  cprintf ("    R O W N A N   L I N I O W Y C H");
  ramka(1,21,5,23,0,0);                     // chowanie kursora
}

void epilog(void)                           // koniec pracy programu      
{
  gotoxy(2,22);
  getch();
  window(1,1,80,25);
  textcolor(7);
  textbackground(0);
  clrscr();
  exit(1);
}

void tablica(void)
{
  int i;
  window(rl-3,rg-1,rp,rd);
  ramka(rl,rg,rp,rd,0,3);
  textcolor(14);
  for(i=1; i<= n; i++)
  {
	gotoxy(rl-3,rg+i);
	sprintf(ss,"%2d",z2[i]);
	cprintf(ss);
  }
  gotoxy(rl+6,rg-1);
  cprintf("0");
  for(i=1; i<=n; i++)
  {
	gotoxy(rl+5+i*8,rg-1);
	sprintf(ss,"%2d",z1[i]);
	cprintf(ss);
  }
}

void Elementy(void)
{
  int i,j;
  tablica();
  for(i=1; i<= n; i++)
	for(j=0; j<= n; j++)
	{
	  gotoxy(rl+2+j*8,rg+i);
	  sprintf(ss,"%7.2lf",a[i][j]);
	  cprintf(ss);
	}
}

void input(void)                            // wprowadzanie danych
{
  int i,j;
  ramka(31,5,49,8,0,3);
  textcolor(14);
  gotoxy(33,6);
  cprintf("Rozmiar zadania");
  gotoxy(36,7);
  cprintf("n(<8) = ");
  scanf("%d",&n);
  window(31,5,49,8);
  clrscr();
  for(i=1; i<= n; i++)
  {
	z1[i]=i;
	z2[i]=i+n;
  }
  rg=10-n/2;
  rd=rg+n+1;
  rl=38-n*4;
  rp=rl+n*8+10;
  tablica();
  for(i=1; i<= n; i++)
  {
	for(j=0; j<= n; j++)
	{
	  gotoxy(rl+3+j*8,rg+i);
	  scanf("%f",a[i]+j);
	}
  }
  Elementy();
}

void WierszCentralny(void)                  // poszukiwanie indeksu r
{
  int i;
  r=0;
  i=1;
  while (r==0 && i<=n)
  {
	if (z2[i]>n && fabs(a[i][0])>eps) r=i;
	i=i+1;
  }
}

void KolumnaCentralna(void)
{
  int j;
  k=0;
  j=1;
  while (k==0 && j<=n)
  {
	if (z1[j]<=n && fabs(a[r][j])>eps) k=j;
	j=j+1;
  }
}

void Eliminacja(void)
{
  int i,j;
  float v0;
  float u[11],v[11];                                   // wektory pomocnicze
  v0=1./a[r][k];
  for(i=1; i<= n; i++) v[i]=a[i][k];
  for(j=0; j<= n ; j++) u[j]=a[r][j]*v0;
  for(i=1; i<=n; i++)
	for(j=0; j<= n ; j++) a[i][j]-=v[i]*u[j];
  for(i=1; i<= n; i++) a[i][k]=-v[i]*v0;
  for(j=0; j<= n; j++) a[r][j]=u[j];
  a[r][k]=v0;
  i=z1[k];
  z1[k]=z2[r];
  z2[r]=i;
}

void Wyniki(void)                           // wyprowadzenie rozwiazania
{
  float x[11];
  int i;
  for(i=1; i<= n ; i++) x[i]=0;
  for(i=1; i<= n ; i++)
	if (z2[i]<=n)
	  x[z2[i]]=a[i][0];
  ramka(rl+4,rd+2,rp-4,rd+6,0,14);
  gotoxy(38,rd+2);
  cprintf("ROZWIAZANIE");
  textcolor(11);
  for(i=1; i<= n ; i++)
  {
	gotoxy(rl+i*8,rd+3);
	sprintf(ss,"x[%d]",i);
	cprintf(ss);
  }
  textcolor(15);
  for(i=1; i<= n ; i++)
  {
	gotoxy(rl-3+i*8,rd+5);
	sprintf(ss,"%7.2f",x[i]);
	cprintf(ss);
  }
  epilog();
}

void Contradiction(void)                    // brak rozwiazan - sprzecznosc
{
  ramka(26,rd+2,60,rd+4,0,12);
  gotoxy(29,rd+3);
  cprintf("Zadanie nie posiada rozwiazan");
  epilog();
}

void PolozenieElementuCentralnego(void)  // wskazanie elementu centralnego
{
  textbackground(7);
  textcolor(0);
  gotoxy(rl+2+k*8,rg+r);
  sprintf(ss,"%f",a[r][k]);
  cprintf(ss);
  gotoxy(2,22);
}

void gauss(void)                            // metoda Gaussa
{
  eps=1.e-5;
  while(1)
  {
	WierszCentralny();
	if (r==0) Wyniki();
	KolumnaCentralna();
	if (k==0) Contradiction();
	PolozenieElementuCentralnego();
	getch();
	Eliminacja();
	Elementy();
  }
}

void main(void)
{
  prolog();                                   // poczatek pracy programu
  input();                                    // wprowadzanie danych
  gauss();                                    // metoda Gaussa
}
